#!/usr/bin/python2.6
from __future__ import print_function

"""

This file was originally used for something else, and before that it
was used for something else again.  As it has been repurposed several
times, it's kind of a sprawling mess.  I apologize.

"""

import os, sys, subprocess, re
import perf
import argparse
from math import *

# The tests are defined near the bottom

MIN_REPS = 3
MIN_TIME = 0.1
MAX_TIME = 1.0

def makedir(x):
    try:
        os.mkdir(x)
    except OSError:
        pass

def rm(x):
    try:
        os.unlink(x)
    except OSError:
        pass

makedir('dat')

setup = ''

def smart_timeit(executable, stmt, setup, hint):
    n = hint
    while 1:
        v = timeit(executable, stmt, setup, n, 3)
        if v[0]*n > MIN_TIME:
            return v, n
        n <<= 1

timeit_cache = {}
def timeit(executable, stmt, setup, rep, n):
    assert rep >= MIN_REPS
    key = (executable, stmt, setup, rep, n)
    if key in timeit_cache:
        return timeit_cache[key]
    try:
        args =[executable, '-m', 'timeit',
               '-r', str(n), '-v', '-n', str(rep), '-s', setup, '--', stmt]
        p = subprocess.Popen(args,
                             stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        so, se = p.communicate()
        try:
            lines = so.split(b'\n')
            raw = lines[0]
            number = int(lines[1].split()[0])
            times = [float(x) / number for x in raw.split()[2:]]
            sortedtimes = sorted(times)
            # median, lower quartile, upper quartile
            v = (sortedtimes[n//2], sortedtimes[n//4], sortedtimes[3*n//4])
            v += tuple(times)
            timeit_cache[key] = v
            return v
        except:
            print(so)
            print(se)
            raise
    except:
        print(stmt)
        print(setup)
        raise

values = {}
def get_timing1(executable, label, setup_n, template, typename, use_rep_map):
    f = open('dat/%s-%s.dat' % (typename, label), 'w')
    print('#', label, file=f)
    print('#', template.replace('\n', '\\n'), file=f)
    if setup_n is None:
        setup_n = "x = list(range(n))"
    else:
        setup_n = setup_n
    if args.graphs:
        makedir('fig')
        ftimeit = open('fig/%s.txt' % label, 'w')
        print('<div class="experiment_inner">Setup: <code>%s</code><br/>' % setup_n.replace('\n', '<br/>'),
              file=ftimeit)
        print('Timed: <code>%s</code></div>' % template.replace('\n', '<br/>'),
              file=ftimeit)
        ftimeit.close()

    for i in reversed(list(range(len(ns)))):
        n = ns[i]
        key = (executable, label, setup_n, n, template, typename)
        print(n, end=' ')
        sys.stdout.flush()
        setup2 = '\nn = %d\n' % (n,)
        setup3 = setup + '\n' + setup2 + setup_n
        stmt = template
        if not use_rep_map:
            if i < len(ns)-1:
                rep_map[n] = max(rep_map[n], rep_map[ns[i+1]])
            v, rep = smart_timeit(executable, stmt, setup3, rep_map[n])
            if rep_map[n] < rep:
                rep_map[n] = rep
        else:
            k = rep_map[n]
            if k * values[key] > MAX_TIME:
                k = max(MIN_REPS, int(ceil(MAX_TIME / values[key])))
            v = timeit(executable, stmt, setup3, k, args.repetitions)
        values[key] = v[0]
        v = [x*1000 for x in v]
        if typename == 'control':
            list_values[n] = v[0]
        print(n, file=f, end=' ')
        for x in v[:3]:
            print(x, file=f, end=' ')
        for x in v[:3]:
            print(x/list_values[n], file=f, end=' ')
        for x in v[3:]:
            print(x, file=f, end=' ')
        print(file=f)
    print()
    f.close()

def get_timing(label, setup_n, template):
    global rep_map, list_values
    rep_map = {}
    list_values = {}
    for n in ns:
        rep_map[n] = MIN_REPS
    print('Calibrating timeit for', label)
    print('   control: ', end='')
    get_timing1(args.control, label, setup_n, template, 'control', False)
    print('   experiment: ', end='')
    get_timing1(args.experiment, label, setup_n, template, 'experiment', False)

    print('Timing', label)
    print('   control: ', end='')
    get_timing1(args.control, label, setup_n, template, 'control', True)
    print('   experiment: ', end='')
    get_timing1(args.experiment, label, setup_n, template, 'experiment', True)

    if args.graphs:
        makedir('fig')
        makedir('fig/relative')
        makedir('fig/absolute')
        makedir('gnuplot')
        plot(label, True)
        plot(label, False)
        html(label)
    summarize(label)

def html(label):
    fname = 'fig/%s.html' % label
    f = open(fname, 'w')
    if timing_d[label][0] is None:
        setup = 'x = list(range(n))'
    else:
        setup = timing_d[label][0]
    print('''
<html>
<head>
<title>Python list timing results: %s</title>
<script src="svg.js"></script>
</head>
<body>
<object data="absolute/%s.svg" width="480" height="360"
	type="image/svg+xml"></object>
<object data="relative/%s.svg" width="480" height="360"
	type="image/svg+xml"></object>
<p>
Setup:
<pre>
%s
</pre>
Timed:
<pre>
%s
</pre>
</body>
</html>
    ''' % (label, label, label, setup, timing_d[label][1]), file=f)
    f.close()

def get_data(label):
    fname = 'dat/%s.dat' % label
    with open(fname) as f:
        data = [line.split() for line in f
                if line and not line.startswith('#')]
    return [[float(v) for v in line] for line in data]

class FakeOptions:
    def __init__(self, label):
        self.control_label = 'control'
        self.experiment_label = 'experiment'
        self.benchmark_name = label
        self.disable_timelines = True

def summarize(label):
    print()
    cdata = get_data('control-%s' % label)
    edata = get_data('experiment-%s' % label)
    output = []
    for cline, eline in zip(cdata, edata):
        n = cline[0]
        print(label, 'n =', n)
        assert cline[0] == eline[0]
        csamples = cline[7:]
        esamples = eline[7:]
        output.append(str(perf.CompareMultipleRuns(csamples, esamples,
                                                   FakeOptions('%s-%d'
                                                               % (label, n)))))
        print(output[-1])
        print()

    if len(output) <= 1:
        return

    data = '\n'.join(output)
    slower = re.findall(r'Avg: .* ([0-9.]+)x slower', data)
    faster = re.findall(r'Avg: .* ([0-9.]+)x faster', data)
    nochange = re.findall(r'Avg: .* no change', data)
    slower = [float(x) for x in slower]
    faster = [1.0/float(x) for x in faster]

    data = slower+faster + [1.0] * len(nochange)

    mean = sum(data)/float(len(data))
    sd = sqrt(sum((x-mean)**2 for x in data) / (len(data)-1))
    se = sd / sqrt(len(data))
    print('%s, 95%% confidence interval across all tests:' % label)
    print('mean:', mean, '+/-', se*1.96)
    if mean + se*1.96 < 1.0:
        print('Experiment is significantly faster')
    elif mean - se*1.96 > 1.0:
        print('Experiment is significantly slower')
    else:
        print('Not significantly different')
    print()

def plot(label, relative):
    safe_label = label.replace('_', '\\\\_')
    fname = 'gnuplot/%s.gnuplot' % label
    f = open(fname, 'w')
    if relative:
        d = 'fig/relative/'
    else:
        d = 'fig/absolute/'
    print("""
set output "%s/%s.svg"
set xlabel "List Size (n)"
set title "%s"
set terminal svg size 480,360 dynamic enhanced
set size noratio 1,1
set key top left
set bars 0.2
set pointsize 0.5
set xtics ("1" 1, "10" 10, "100" 100, "1k" 1000, "10k" 10000, "100k" 100000, "1M" 1000000)
""" % (d, label, safe_label), file=f)

    if relative:
        print('set title "Normalized Execution Times, log-linear scale"', file=f)
        print('set logscale x', file=f)
        print('set yrange [0:*]', file=f)
        print('set yrange [0:200]', file=f)
        print('set ylabel "Execution Time (%)"', file=f)
        k = 3
        m = 100.0
    else:
        print('set title "Raw Execution Times, log-log scale"', file=f)
        print('set logscale xy', file=f)
        print('set yrange [0.00001:10]', file=f)
        print('set ylabel "Execution Time"', file=f)
        print('set ytics ("1 ns" 0.000001, "10 ns" 0.00001, "100 ns" 0.0001, "1 us" 0.001, "10 us" 0.01, "100 us" 0.1, "1 ms" 1.0, "10 ms" 10.0, "100 ms" 100.0)', file=f)
        k = 0
        m = 1.0

    print (('plot "dat/control-%s.dat" using 1:(%f*$%d):(%f*$%d):(%f*$%d) title "control" with yerr pt 1, \\' % (label, m, k+2, m, k+3, m, k+4)), file=f)
    print (('    "dat/experiment-%s.dat" using 1:(%f*$%d):(%f*$%d):(%f*$%d) title "experiment" with yerr pt 1 '% (label, m, k+2, m, k+3, m, k+4)), file=f)
    print(file=f)
    f.flush()
    f.close()
    if os.system('gnuplot "%s"' % fname):
        raise RuntimeError('Gnuplot failure')

timing_d = {}
def add_timing(name, auto, stmt):
    timing_d[name] = (auto, stmt)

def run_timing(name):
    auto, stmt = timing_d[name]
    get_timing(name, auto, stmt)

def run_all():
    for k in sorted(timing_d):
        run_timing(k)

########################################################################
# Tests to run are below here.
# The arguments to add_timing are as follows:
#   1) name of the test
#   2) setup code to run once.  "None" means x = list(range(n))
#   3) code to execute repeatedly in a loop
#
# The following symbols will autoamtically be defined:
#   - n

add_timing('sort random', 'import random\nx = [random.randrange(n*4) for i in range(n)]\ny=list(x)\nf=y.sort', 'y[:] = x\nf()')
add_timing('sort random key', 'import random\nx = [random.randrange(n*4) for i in range(n)]\ny=list(x)\nf=y.sort', 'y[:] = x\nf(key=int)')
add_timing('sort sorted', 'x = list(range(n))\nf = x.sort', 'f()')
add_timing('sort sorted key', 'x = list(range(n))\nf = x.sort', 'f(key=int)')
add_timing('sort reversed', 'x = list(range(n))\nx.reverse()\nf = x.sort\ng=x.reverse', 'f()\ng()')
add_timing('sort reversed key', 'x = list(range(n))\nx.reverse()\nf = x.sort\ng=x.reverse', 'f(key=int)\ng()')

add_timing('sort random tuples', 'import random\nx = [(random.random(), random.random()) for i in range(n)]\ny = list(x)\nf=y.sort', 'y[:]=x\nf()')

ob_def = '''
import random
class ob:
    def __init__(self, v):
        self.v = v
    def __lt__(self, other):
        return self.v < other.v
x = [ob(random.randrange(n*4)) for i in range(n)]
y = list(x)
f = y.sort
'''

add_timing('sort random objects', ob_def, 'y[:]=x\nf()')
add_timing('sort sorted objects', ob_def + 'f()', 'f()')

parser = argparse.ArgumentParser(description="Compare the speed of two list implementations", epilog="Available experiments:\n" + '\n'.join(timing_d),
                                 formatter_class=argparse.RawDescriptionHelpFormatter)

parser.add_argument('control', help='control/python')
parser.add_argument('experiment', help='experiment/python')

parser.add_argument('--minn', dest='minn', type=int, default=0,
                    help='Minimum list size')
parser.add_argument('--maxn', dest='maxn', type=int, default=100000,
                    help='Maximum list size')
parser.add_argument('-r, --repetitions', dest='repetitions',
                    type=int, default=11, help='Repetitions; how many times to repeat each experiment')
parser.add_argument('tests', nargs='*',
                    help='Names of tests to conduct')
parser.add_argument('--graphs', default=False, action='store_true',
                    help='Generate performance graphs as a function of n; requires gnuplot')

if __name__ == '__main__':
    args = parser.parse_args()
    if os.path.isdir(args.control):
        args.control = os.path.join(args.control, 'python')
    if os.path.isdir(args.experiment):
        args.experiment = os.path.join(args.experiment, 'python')
    ns = [0]
    if args.maxn > 0:
        for i in range(int(round(log(args.maxn)/log(10)*10)+1)):
            ns.append(int(floor(10**(i*0.1))))
    ns = [i for i in set(ns) if i >= args.minn]
    ns.sort()
    if not args.tests:
        run_all()
    else:
        for name in args.tests:
            run_timing(name)
